require "helper"
require "fluent/plugin/parser_heroku_parser.rb"

class HerokuParserTest < Test::Unit::TestCase
  setup do
    Fluent::Test.setup
  end

  # test "failure" do
  #   flunk
  # end

  def test_match_pattern
    d = create_driver({})
    record = d.instance.parse('Nov 10 04:07:59 d.2afc0034-4f4b-43c5-9bba-a7a75095b643 heroku[router] sock=client at=warning code=H27 desc="Client Request Interrupted" method=POST path="/peripheral_logs/bulk.json?auth_token=Pw8L6TEsyjM5ztP7vZ4n&app_token=tBlBMK4yOFNrunWll1asJA==" host=user.mamorio.jp request_id=cf2ab614-1a86-463c-66a3-5fae752eca92 fwd="110.165.145.182" dyno=web.4 connect=0ms service=60117ms status=503 bytes=561 tls_version=tls1.2')
    puts(record)

    record = d.instance.parse('Nov 10 04:07:59 d.2afc0034-4f4b-43c5-9bba-a7a75095b643 heroku[router] sock=client at=warning method=POST path="/peripheral_logs/bulk.json" host=user.mamorio.jp request_id=cf2ab614-1a86-463c-66a3-5fae752eca92 fwd="110.165.145.182" dyno=web.4 connect=0ms service=60117ms status=503 bytes=561 tls_version=tls1.2')
    puts(record)
  end

  private

  def create_driver(conf)
    Fluent::Test::Driver::Parser.new(Fluent::TextParser::HerokuParser).configure(conf)
  end

  def exec_test(text, expected_time, expected_record)
    d = create_driver({})
    d.instance.parser(text) {|time, record|
      assert_equal(expected_time, time) if expected_time
      assert_equal(expected_record, record)
    }
  end
end
